## libcap2 2.32

=== Makefile ===
#
# Makefile for libcap
#
topdir=$(shell pwd)
include Make.Rules

#
# flags
#

all install clean kdebug: %: %-here
	$(MAKE) -C libcap $@
ifneq ($(PAM_CAP),no)
	$(MAKE) -C pam_cap $@
endif
ifeq ($(GOLANG),yes)
	$(MAKE) -C go $@
endif
	$(MAKE) -C tests $@
	$(MAKE) -C progs $@
	$(MAKE) -C doc $@
	$(MAKE) -C kdebug $@

all-here:

install-here:

clean-here:
	$(LOCALCLEAN)

distclean: clean
	$(DISTCLEAN)

release: distclean
	cd .. && ln -s libcap libcap-$(VERSION).$(MINOR) && tar cvf libcap-$(VERSION).$(MINOR).tar --exclude patches libcap-$(VERSION).$(MINOR)/* && rm libcap-$(VERSION).$(MINOR)

test: all
	make -C libcap $@
	make -C tests $@
ifneq ($(PAM_CAP),no)
	$(MAKE) -C pam_cap $@
endif
ifeq ($(GOLANG),yes)
	make -C go $@
endif
	make -C progs $@

sudotest: all
	make -C tests $@
ifneq ($(PAM_CAP),no)
	$(MAKE) -C pam_cap $@
endif
ifeq ($(GOLANG),yes)
	make -C go $@
endif
	make -C progs $@

morganrelease: distclean
	@echo "sign the tag twice: older DSA key; and newer RSA kernel.org key"
	git tag -u D41A6DF2 -s libcap-$(VERSION).$(MINOR) -m "This is libcap-$(VERSION).$(MINOR)"
	git tag -u E2CCF3F4 -s libcap-korg-$(VERSION).$(MINOR) -m "This is libcap-$(VERSION).$(MINOR)"
	make release
	@echo "sign the tar file using korg key"
	cd .. && gpg -sba -u E2CCF3F4 libcap-$(VERSION).$(MINOR).tar

=== libcap/Makefile ===
#
# defines
#
topdir=$(shell pwd)/..
include ../Make.Rules
#
# Library version
#
LIBNAME=$(LIBTITLE).so
STACAPLIBNAME=$(LIBTITLE).a
#
STAPSXLIBNAME=libpsx.a

CAPFILES=cap_alloc cap_proc cap_extint cap_flag cap_text cap_file
PSXFILES=psx

INCLS=libcap.h cap_names.h $(INCS)
CAPOBJS=$(addsuffix .o, $(CAPFILES))
PSXOBJS=$(addsuffix .o, $(PSXFILES))

MAJLIBNAME=$(LIBNAME).$(VERSION)
MINLIBNAME=$(MAJLIBNAME).$(MINOR)
GPERF_OUTPUT = _caps_output.gperf

all: $(MINLIBNAME) $(STACAPLIBNAME) libcap.pc libpsx.pc $(STAPSXLIBNAME)

ifeq ($(BUILD_GPERF),yes)
USE_GPERF_OUTPUT = $(GPERF_OUTPUT)
INCLUDE_GPERF_OUTPUT = -DINCLUDE_GPERF_OUTPUT='"$(GPERF_OUTPUT)"'
endif

libcap.pc: libcap.pc.in
	sed -e 's,@prefix@,$(prefix),' \
		-e 's,@exec_prefix@,$(exec_prefix),' \
		-e 's,@libdir@,$(LIBDIR),' \
		-e 's,@includedir@,$(inc_prefix)/include,' \
		-e 's,@VERSION@,$(VERSION).$(MINOR),' \
		-e 's,@deps@,$(DEPS),' \
		$< >$@

libpsx.pc: libpsx.pc.in
	sed -e 's,@prefix@,$(prefix),' \
		-e 's,@exec_prefix@,$(exec_prefix),' \
		-e 's,@libdir@,$(LIBDIR),' \
		-e 's,@includedir@,$(inc_prefix)/include,' \
		-e 's,@VERSION@,$(VERSION).$(MINOR),' \
		-e 's,@deps@,$(DEPS),' \
		$< >$@

_makenames: _makenames.c cap_names.list.h
	$(BUILD_CC) $(BUILD_CFLAGS) $< -o $@

cap_names.h: _makenames
	./_makenames > cap_names.h

$(GPERF_OUTPUT): cap_names.list.h
	perl -e 'print "struct __cap_token_s { const char *name; int index; };\n%{\nconst struct __cap_token_s *__cap_lookup_name(const char *, size_t);\n%}\n%%\n"; while ($$l = <>) { $$l =~ s/[\{\"]//g; $$l =~ s/\}.*// ; print $$l; }' < $< | gperf --ignore-case --language=ANSI-C --readonly --null-strings --global-table --hash-function-name=__cap_hash_name --lookup-function-name="__cap_lookup_name" -c -t -m20 $(INDENT) > $@
	sed -e 's/unsigned int len/size_t len/' -i $@

cap_names.list.h: Makefile $(KERNEL_HEADERS)/linux/capability.h
	@echo "=> making $@ from $(KERNEL_HEADERS)/linux/capability.h"
	perl -e 'while ($$l=<>) { if ($$l =~ /^\#define[ \t](CAP[_A-Z]+)[ \t]+([0-9]+)\s+$$/) { $$tok=$$1; $$val=$$2; $$tok =~ tr/A-Z/a-z/; print "{\"$$tok\",$$val},\n"; } }' $(KERNEL_HEADERS)/linux/capability.h | fgrep -v 0x > $@

$(STACAPLIBNAME): $(CAPOBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

$(STAPSXLIBNAME): $(PSXOBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

$(MINLIBNAME): $(CAPOBJS)
	$(LD) $(CFLAGS) $(LDFLAGS) -Wl,-soname,$(MAJLIBNAME) -o $@ $^
	ln -sf $(MINLIBNAME) $(MAJLIBNAME)
	ln -sf $(MAJLIBNAME) $(LIBNAME)

%.o: %.c $(INCLS)
	$(CC) $(CFLAGS) $(IPATH) -c $< -o $@

cap_text.o: cap_text.c $(USE_GPERF_OUTPUT) $(INCLS)
	$(CC) $(CFLAGS) $(IPATH) $(INCLUDE_GPERF_OUTPUT) -c $< -o $@

cap_test: cap_test.c libcap.h
	$(CC) $(CFLAGS) $(IPATH) $< -o $@

test: cap_test
	./cap_test

install: all
	mkdir -p -m 0755 $(FAKEROOT)$(INCDIR)/sys
	install -m 0644 include/sys/capability.h $(FAKEROOT)$(INCDIR)/sys
	install -m 0644 include/sys/psx_syscall.h $(FAKEROOT)$(INCDIR)/sys
	mkdir -p -m 0755 $(FAKEROOT)$(LIBDIR)
	install -m 0644 $(STACAPLIBNAME) $(FAKEROOT)$(LIBDIR)/$(STACAPLIBNAME)
	install -m 0644 $(STAPSXLIBNAME) $(FAKEROOT)$(LIBDIR)/$(STAPSXLIBNAME)
	install -m 0644 $(MINLIBNAME) $(FAKEROOT)$(LIBDIR)/$(MINLIBNAME)
	ln -sf $(MINLIBNAME) $(FAKEROOT)$(LIBDIR)/$(MAJLIBNAME)
	ln -sf $(MAJLIBNAME) $(FAKEROOT)$(LIBDIR)/$(LIBNAME)
ifeq ($(FAKEROOT),)
	-/sbin/ldconfig
endif
	mkdir -p -m 0755 $(FAKEROOT)$(PKGCONFIGDIR)
	install -m 0644 libcap.pc $(FAKEROOT)$(PKGCONFIGDIR)/libcap.pc
	install -m 0644 libpsx.pc $(FAKEROOT)$(PKGCONFIGDIR)/libpsx.pc

clean:
	$(LOCALCLEAN)
	rm -f $(CAPOBJS) $(LIBNAME)* $(STACAPLIBNAME) libcap.pc libpsx.pc
	rm -f $(PSXOBJS) $(STAPSXLIBNAME)
	rm -f cap_names.h cap_names.list.h _makenames $(GPERF_OUTPUT) cap_test
	cd include/sys && $(LOCALCLEAN)

=== pam_cap/Makefile ===
# simple make file for the pam_cap module

topdir=$(shell pwd)/..
include ../Make.Rules

all: pam_cap.so
	$(MAKE) testlink

install: all
	mkdir -p -m 0755 $(FAKEROOT)$(LIBDIR)/security
	install -m 0755 pam_cap.so $(FAKEROOT)$(LIBDIR)/security

# Note (as the author of much of the Linux-PAM library, I am confident
# that this next line does *not* require -lpam on it.) If you think it
# does, *verify that it does*, and if you observe that it fails as
# written (and you know why it fails), email me and explain why. Thanks!

pam_cap.so: pam_cap.o
	$(LD) -o pam_cap.so $< $(LIBCAPLIB) $(LDFLAGS)

pam_cap.o: pam_cap.c
	$(CC) $(CFLAGS) $(IPATH) -c $< -o $@

test_pam_cap: test_pam_cap.c pam_cap.c
	$(CC) $(CFLAGS) $(IPATH) -o $@ test_pam_cap.c $(LIBCAPLIB) $(LDFLAGS) --static

testlink: test.c pam_cap.o
	$(CC) $(CFLAGS) -o $@ $+ -lpam -ldl $(LIBCAPLIB) $(LDFLAGS)

test: pam_cap.so
	make testlink

sudotest: test test_pam_cap
	sudo ./test_pam_cap root 0x0 0x0 0x0 config=./capability.conf
	sudo ./test_pam_cap root 0x0 0x0 0x0 config=./sudotest.conf
	sudo ./test_pam_cap alpha 0x0 0x0 0x0 config=./capability.conf
	sudo ./test_pam_cap alpha 0x0 0x1 0x80 config=./sudotest.conf
	sudo ./test_pam_cap beta 0x0 0x1 0x0 config=./sudotest.conf
	sudo ./test_pam_cap gamma 0x0 0x0 0x81 config=./sudotest.conf
	sudo ./test_pam_cap delta 0x41 0x80 0x41 config=./sudotest.conf

clean:
	rm -f *.o *.so testlink test_pam_cap *~

=== progs/Makefile ===

topdir=$(shell pwd)/..
include $(topdir)/Make.Rules
#
# Programs: all of the examples that we will compile
#
PROGS=getpcaps capsh getcap setcap

BUILD=$(PROGS)

ifneq ($(DYNAMIC),yes)
LDFLAGS += --static
endif

DEPS=../libcap/libcap.a ../libcap/libpsx.a

all: $(BUILD)

$(DEPS):
	make -C ../libcap all

$(BUILD): %: %.o $(DEPS)
	$(CC) $(CFLAGS) -o $@ $< $(LIBCAPLIB) $(LDFLAGS)

%.o: %.c $(INCS)
	$(CC) $(IPATH) $(CFLAGS) -c $< -o $@

install: all
	mkdir -p -m 0755 $(FAKEROOT)$(SBINDIR)
	for p in $(PROGS) ; do \
		install -m 0755 $$p $(FAKEROOT)$(SBINDIR) ; \
	done
ifeq ($(RAISE_SETFCAP),yes)
	$(FAKEROOT)$(SBINDIR)/setcap cap_setfcap=i $(FAKEROOT)$(SBINDIR)/setcap
endif

test: $(PROGS)

sudotest: test
	sudo ./quicktest.sh

clean:
	$(LOCALCLEAN)
	rm -f *.o $(BUILD) tcapsh ping hack.sh compare-cap

=== contrib/golang/Makefile ===
all: posix.go posix-cgo.go
	CGO_ENABLED=0 go build posix.go
	go build posix-cgo.go

posix.go: ptest.go posix.stub_go Makefile
	sed -e '/\/\/ main_here/ r posix.stub_go' ptest.go > $@

posix-cgo.go: ptest.go posix-cgo.stub_go Makefile
	sed -e '/\/\/ main_here/ r posix-cgo.stub_go' ptest.go > $@

clean:
	rm -f posix.go posix
	rm -f posix-cgo.go posix-cgo

=== debian/changelog ===
libcap2 (1:2.32-1ubuntu0.2) focal-security; urgency=medium

  * SECURITY UPDATE: incorrect group name handling
    - debian/patches/CVE-2025-1390-1.patch: fix potential configuration
      parsing error in pam_cap/pam_cap.c.
    - debian/patches/CVE-2025-1390-2.patch: add a test for bad group prefix
      in pam_cap/sudotest.conf.
    - CVE-2025-1390

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 20 Feb 2025 11:01:08 -0500

libcap2 (1:2.32-1ubuntu0.1) focal-security; urgency=medium

  * SECURITY UPDATE: process memory exhaustion in pthread_create()
    - debian/patches/CVE-2023-2602.patch: correct the check of
      pthread_create()'s return value in libcap/psx.c.
    - CVE-2023-2602
  * SECURITY UPDATE: integer overflow in _libcap_strdup()
    - debian/patches/CVE-2023-2603.patch: properly handle large strings in
      libcap/cap_alloc.c.
    - CVE-2023-2603

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 07 Jun 2023 09:02:37 -0400

libcap2 (1:2.32-1) unstable; urgency=medium

  * New upstream release.
    - Refresh patches
    - Fixes an issue introduced in 2.31 that breaks fakeroot. (Closes: #951492)

 -- Christian Kastner <ckk@debian.org>  Mon, 17 Feb 2020 13:44:20 +0100

libcap2 (1:2.31-1) unstable; urgency=medium

  * New upstream release.
    - Refresh patches
    - Update symbols file (symbols added)
  * Bump Standards-Version to 4.5.0 (no changes needed)
  * Add lintian-override for orig-tarball-missing-upstream-signature

 -- Christian Kastner <ckk@debian.org>  Sun, 09 Feb 2020 14:52:11 +0100

=== debian/control ===
Source: libcap2
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Christian Kastner <ckk@debian.org>
Build-Depends:
    debhelper-compat (= 12),
    indent,
    libpam0g-dev,
    gperf (>= 3.1),
Rules-Requires-Root: dpkg/target-subcommand
Standards-Version: 4.5.0
Homepage: https://sites.google.com/site/fullycapable/
Vcs-Git: https://salsa.debian.org/debian/libcap2.git
Vcs-Browser: https://salsa.debian.org/debian/libcap2

Package: libcap2-bin
Section: utils
Priority: important
Architecture: linux-any
Multi-Arch: foreign
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
Breaks: libcap-bin
Replaces: libcap-bin
Recommends: libpam-cap
Description: POSIX 1003.1e capabilities (utilities)
 Libcap implements the user-space interfaces to the POSIX 1003.1e capabilities
 available in Linux kernels. These capabilities are a partitioning of the all
 powerful root privilege into a set of distinct privileges.
 .
 This package contains additional utilities.

Package: libcap2
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
Description: POSIX 1003.1e capabilities (library)
 Libcap implements the user-space interfaces to the POSIX 1003.1e capabilities
 available in Linux kernels. These capabilities are a partitioning of the all
 powerful root privilege into a set of distinct privileges.
 .
 This package contains the shared library.

Package: libcap-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    libcap2 (= ${binary:Version}),
Suggests: manpages-dev
Provides: libcap2-dev
Description: POSIX 1003.1e capabilities (development)
 Libcap implements the user-space interfaces to the POSIX 1003.1e capabilities
 available in Linux kernels. These capabilities are a partitioning of the all
 powerful root privilege into a set of distinct privileges.
 .
 This package contains the development files.

Package: libpam-cap
Section: admin
Architecture: linux-any
Multi-Arch: same
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    libpam-runtime (>= 1.1.3-2~),
Breaks: libcap2-bin (<< 1:2.22-1.1)
Replaces: libcap2-bin (<< 1:2.22-1.1)
Description: POSIX 1003.1e capabilities (PAM module)
 Libcap implements the user-space interfaces to the POSIX 1003.1e capabilities
 available in Linux kernels. These capabilities are a partitioning of the all
 powerful root privilege into a set of distinct privileges.
 .
 This package contains the PAM module for enforcing capabilities on users and
 groups at PAM session start time.

Package: libcap2-udeb
Section: debian-installer
Architecture: linux-any
Package-Type: udeb
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
Description: POSIX 1003.1e capabilities (library)
 Libcap implements the user-space interfaces to the POSIX 1003.1e capabilities
 available in Linux kernels. These capabilities are a partitioning of the all
 powerful root privilege into a set of distinct privileges.
 .
 This is a minimal version, only for use in the installation system.

=== debian/rules ===
#!/usr/bin/make -f

# Pass this as version-info to dh_makeshlibs
SHLIBS_MINVER = 1:2.26

# Exports DEB_{BUILD,HOST}_* flags
include /usr/share/dpkg/architecture.mk
# Export DEB_VERSION, among other things
include /usr/share/dpkg/pkg-info.mk

# Support cross-compiling
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
CC := $(DEB_HOST_GNU_TYPE)-gcc
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# One upstream target requires the BUILD compiler instead of HOST
BUILD_CC ?= cc
export BUILD_LDFLAGS = $(shell dpkg-architecture -a$(DEB_BUILD_ARCH) -c dpkg-buildflags --get LDFLAGS)
export BUILD_CPPFLAGS = $(shell dpkg-architecture -a$(DEB_BUILD_ARCH) -c dpkg-buildflags --get CPPFLAGS)


%:
	dh ${@}


override_dh_auto_build:
	dh_auto_build -- CC=$(CC) BUILD_CC=$(BUILD_CC)


override_dh_installdirs:
	dh_installdirs

	# While the PAM module and the library are in /lib, according to the
	# FHS, development files must go into usr/lib/<triplet>.
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)


override_dh_auto_install:
	dh_auto_install -- lib=lib/$(DEB_HOST_MULTIARCH) RAISE_SETFCAP=no

	# libcap-dev:
	#   Move the development files from lib/ to usr/lib. dh_link will
	#   later correct the link for us (from relative to absolute).
	cd debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) && \
		mv    ../../../lib/$(DEB_HOST_MULTIARCH)/*.a . && \
		ln -s ../../../lib/$(DEB_HOST_MULTIARCH)/libcap.so.*.* libcap.so
	sed -i -e 's#^libdir=.*#libdir=/usr/lib/$(DEB_HOST_MULTIARCH)#' \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/libcap.pc

	# Remove unwanted/unused files (because of --fail-missing)
	rm -f debian/tmp/lib/$(DEB_HOST_MULTIARCH)/*.so


override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
 ifeq ($(DEB_RULES_REQUIRES_ROOT),dpkg/target-subcommand)
  ifeq (,$(findstring fakeroot,$(DEB_GAIN_ROOT_CMD)))
	make test
  else
	@echo 'Warning: Tests require real root, not fakeroot.  Skipping.' >&2
  endif
 else ifeq (0,$(shell id -u))
	make test
 else
	@echo 'Warning: Tests require root.  Skipping.' >&2
 endif
endif


override_dh_missing:
	dh_missing --fail-missing


override_dh_makeshlibs:
	dh_makeshlibs -V'libcap2 (>= $(SHLIBS_MINVER))' -plibcap2 \
		--add-udeb=libcap2-udeb -- -c4
	dh_makeshlibs --remaining-packages -- -c4

=== debian/tests/control ===
Tests: executables
Restrictions: needs-root
Depends: libcap2-bin, libc-dev, gcc

## libcap2 2.43

=== debian/changelog ===
libcap2 (1:2.43-1) unstable; urgency=medium

  * New upstream release.
    - Refresh patches
    - Drop patches included upstream

 -- Christian Kastner <ckk@debian.org>  Sun, 23 Aug 2020 22:23:14 +0200

libcap2 (1:2.42-2) unstable; urgency=medium

  * New upstream version 2.42
    - Refresh patches
    - Add Move-mkdir-to-common-install-target.patch
  * Drop Debian-specific man page for getpcaps

 -- Christian Kastner <ckk@debian.org>  Fri, 07 Aug 2020 00:14:04 +0200

libcap2 (1:2.36-1) unstable; urgency=medium

  * New upstream version 2.36
    - Drop patches included upstream
      + Syntax-fixes-for-man-pages.patch
      + Avoid-sys-capability.h-on-build-architecture.patch
      + Spelling-fixes.patch
      + pam_cap-Honor-PAM_REINITIALIZE_CRED.patch
      + Fixes-for-man-page-typos.patch

 -- Christian Kastner <ckk@debian.org>  Sat, 20 Jun 2020 23:27:24 +0200

libcap2 (1:2.34-2) unstable; urgency=medium

  * Bump shlibs version to 2.33 (new symbols)
    This was overlooked in the 2.33 release, where only the symbols file was
    updated.

 -- Christian Kastner <ckk@debian.org>  Sat, 16 May 2020 10:20:58 +0200

libcap2 (1:2.34-1) unstable; urgency=medium

  * New upstream release.
    - Refresh patches
    - Override changed PKGCONFIGDIR in d/rules
    - Drop symbol _cap_names from libcap2.symbols.
      It was never part of the API, and its definition has now been fixed

 -- Christian Kastner <ckk@debian.org>  Wed, 13 May 2020 01:46:31 +0200

libcap2 (1:2.33-1) unstable; urgency=medium

  * New upstream release.
    - Refresh patches
    - Add new symbols to libcap2.symbols

 -- Christian Kastner <ckk@debian.org>  Fri, 27 Mar 2020 12:58:42 +0100

=== debian/rules ===
--- 
+++ 
@@ -1,21 +1,19 @@
 #!/usr/bin/make -f
 
 # Pass this as version-info to dh_makeshlibs
-SHLIBS_MINVER = 1:2.26
+SHLIBS_MINVER = 1:2.33
 
 # Exports DEB_{BUILD,HOST}_* flags
 include /usr/share/dpkg/architecture.mk
-# Export DEB_VERSION, among other things
-include /usr/share/dpkg/pkg-info.mk
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 # Support cross-compiling
 ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
 CC := $(DEB_HOST_GNU_TYPE)-gcc
 endif
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-
-# One upstream target requires the BUILD compiler instead of HOST
+# One upstream target, "_makenames", requires the BUILD compiler instead of HOST
 BUILD_CC ?= cc
 export BUILD_LDFLAGS = $(shell dpkg-architecture -a$(DEB_BUILD_ARCH) -c dpkg-buildflags --get LDFLAGS)
 export BUILD_CPPFLAGS = $(shell dpkg-architecture -a$(DEB_BUILD_ARCH) -c dpkg-buildflags --get CPPFLAGS)
@@ -31,14 +29,16 @@
 
 override_dh_installdirs:
 	dh_installdirs
-
 	# While the PAM module and the library are in /lib, according to the
 	# FHS, development files must go into usr/lib/<triplet>.
 	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
 
 
 override_dh_auto_install:
-	dh_auto_install -- lib=lib/$(DEB_HOST_MULTIARCH) RAISE_SETFCAP=no
+	dh_auto_install -- \
+		lib=lib/$(DEB_HOST_MULTIARCH) \
+		PKGCONFIGDIR=/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
+		RAISE_SETFCAP=no
 
 	# libcap-dev:
 	#   Move the development files from lib/ to usr/lib. dh_link will

## libcap2 2.44

=== Makefile ===
--- 
+++ 
@@ -15,6 +15,7 @@
 endif
 ifeq ($(GOLANG),yes)
 	$(MAKE) -C go $@
+	rm -f cap/go.sum
 endif
 	$(MAKE) -C tests $@
 	$(MAKE) -C progs $@
@@ -30,6 +31,12 @@
 
 distclean: clean
 	$(DISTCLEAN)
+	@echo "CONFIRM Go package cap has right version dependency on cap/psx:"
+	for x in $$(find . -name go.mod); do grep -F -v "module" $$x | fgrep "kernel.org/pub/linux/libs/security/libcap" > /dev/null || continue ; grep -F "v$(GOMAJOR).$(VERSION).$(MINOR)" $$x  > /dev/null && continue ; echo "$$x is not updated to v$(GOMAJOR).$(VERSION).$(MINOR)" ; exit 1 ; done
+	@echo "ALL go.mod files updated"
+	@echo "Now validate that everything is checked in to a clean tree.."
+	test -z "$$(git status -s)"
+	@echo "All good!"
 
 release: distclean
 	cd .. && ln -s libcap libcap-$(VERSION).$(MINOR) && tar cvf libcap-$(VERSION).$(MINOR).tar --exclude patches libcap-$(VERSION).$(MINOR)/* && rm libcap-$(VERSION).$(MINOR)
@@ -55,10 +62,28 @@
 endif
 	make -C progs $@
 
-morganrelease: distclean
-	@echo "sign the tag twice: older DSA key; and newer RSA kernel.org key"
+distcheck:
+	./distcheck.sh
+	make CC=/usr/local/musl/bin/musl-gcc clean all test sudotest
+	make clean all test sudotest
+	make distclean
+
+morgangodoc:
+	@echo "Now the release is made, you want to remember to run:"
+	@echo
+	@echo "GOPROXY=https://proxy.golang.org GO111MODULE=on go get kernel.org/pub/linux/libs/security/libcap/cap@v$(GOMAJOR).$(VERSION).$(MINOR)"
+	@echo
+	@echo "This will cause a go.dev documentation update."
+
+morganrelease: distcheck
+	@echo "sign the main library tag twice: older DSA key; and newer RSA (kernel.org) key"
 	git tag -u D41A6DF2 -s libcap-$(VERSION).$(MINOR) -m "This is libcap-$(VERSION).$(MINOR)"
 	git tag -u E2CCF3F4 -s libcap-korg-$(VERSION).$(MINOR) -m "This is libcap-$(VERSION).$(MINOR)"
+	@echo "The following are for the Go module tracking."
+	git tag -u D41A6DF2 -s v$(GOMAJOR).$(VERSION).$(MINOR) -m "This is the version tag for the 'libcap' Go base directory associated with libcap-$(VERSION).$(MINOR)."
+	git tag -u D41A6DF2 -s psx/v$(GOMAJOR).$(VERSION).$(MINOR) -m "This is the version tag for the 'psx' Go package associated with libcap-$(VERSION).$(MINOR)."
+	git tag -u D41A6DF2 -s cap/v$(GOMAJOR).$(VERSION).$(MINOR) -m "This is the version tag for the 'cap' Go package associated with libcap-$(VERSION).$(MINOR)."
 	make release
 	@echo "sign the tar file using korg key"
 	cd .. && gpg -sba -u E2CCF3F4 libcap-$(VERSION).$(MINOR).tar
+	make morgangodoc

=== doc/Makefile ===
#
# Makefile for libcap documentation
#

topdir=$(shell pwd)/..
include $(topdir)/Make.Rules

MAN1S = capsh.1
MAN3S = cap_init.3 cap_free.3 cap_dup.3 \
	cap_clear.3 cap_clear_flag.3 cap_get_flag.3 cap_set_flag.3 \
	cap_compare.3 cap_get_proc.3 cap_get_pid.3 cap_set_proc.3 \
	cap_get_file.3 cap_get_fd.3 cap_set_file.3 cap_set_fd.3 \
	cap_copy_ext.3 cap_size.3 cap_copy_int.3 \
	cap_from_text.3 cap_to_text.3 cap_from_name.3 cap_to_name.3 \
	capsetp.3 capgetp.3 libcap.3 \
	cap_get_bound.3 cap_drop_bound.3 \
	cap_get_mode.3 cap_set_mode.3 cap_mode_name.3 \
	cap_get_secbits.3 cap_set_secbits.3 \
	cap_setuid.3 cap_setgroups.3 \
	psx_syscall.3 psx_syscall3.3 psx_syscall6.3 libpsx.3
MAN8S = getcap.8 setcap.8 getpcaps.8

MANS = $(MAN1S) $(MAN3S) $(MAN8S)

all: $(MANS)

.PHONY: html
html:
	mkdir -p html
	for man in $(MANS) ; \
	do \
		egrep '^\.so man' $$man > /dev/null || \
		groff -man -Thtml $$man > html/$$man.html ; \
	done

install:
	mkdir -p -m 755 $(FAKEROOT)$(MANDIR)/man1 $(FAKEROOT)$(MANDIR)/man3 $(FAKEROOT)$(MANDIR)/man8
	for man in \
		$(FAKEROOT)$(MANDIR)/man1 $(MAN1S) \
		$(FAKEROOT)$(MANDIR)/man3 $(MAN3S) \
		$(FAKEROOT)$(MANDIR)/man8 $(MAN8S) \
		; \
	do \
		case $$man in \
		/*)	sub=$$man ; continue ;; \
		esac; \
		install -m 644 $$man $$sub ; \
	done

clean:
	$(LOCALCLEAN)
	rm -rf html

=== go/Makefile ===
# Building the libcap/{cap.psx} Go packages, and examples.
#
# Note, we use symlinks to construct a GOPATH friendly src tree. The
# packages themselves are intended to be (ultimately) found via proxy
# as "kernel.org/pub/linux/libs/security/libcap/cap" and
# "kernel.org/pub/linux/libs/security/libcap/psx". However, to
# validate their use on these paths, we fake such a structure in the
# build tree with symlinks.

topdir=$(realpath ..)
include $(topdir)/Make.Rules

GOPATH=$(realpath .)
IMPORTDIR=kernel.org/pub/linux/libs/security/libcap
PKGDIR=pkg/$(GOOSARCH)/$(IMPORTDIR)
PSXGOPACKAGE=$(PKGDIR)/psx.a
CAPGOPACKAGE=$(PKGDIR)/cap.a

DEPS=../libcap/libcap.a ../libcap/libpsx.a

all: $(PSXGOPACKAGE) $(CAPGOPACKAGE) web compare-cap try-launching

$(DEPS):
	make -C ../libcap all

../progs/tcapsh-static:
	make -C ../progs tcapsh-static

src/$(IMPORTDIR)/psx:
	mkdir -p "src/$(IMPORTDIR)"
	ln -s $(topdir)/psx $@

src/$(IMPORTDIR)/cap:
	mkdir -p "src/$(IMPORTDIR)"
	ln -s $(topdir)/cap $@

$(topdir)/libcap/cap_names.h: $(DEPS)
	make -C $(topdir)/libcap all

good-names.go: $(topdir)/libcap/cap_names.h src/$(IMPORTDIR)/cap  mknames.go
	$(GO) run mknames.go --header=$< --textdir=$(topdir)/doc/values | gofmt > $@ || rm -f $@
	diff -u ../cap/names.go $@

$(PSXGOPACKAGE): src/$(IMPORTDIR)/psx ../psx/*.go $(DEPS)
	mkdir -p pkg
	GO111MODULE=off CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" GOPATH="$(GOPATH)" $(GO) install $(IMPORTDIR)/psx

$(CAPGOPACKAGE): src/$(IMPORTDIR)/cap ../cap/*.go good-names.go $(PSXGOPACKAGE)
	GO111MODULE=off CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" GOPATH=$(GOPATH) $(GO) install $(IMPORTDIR)/cap

# Compiles something with this package to compare it to libcap. This
# tests more when run under sudotest (see ../progs/quicktest.sh for that).
compare-cap: compare-cap.go $(CAPGOPACKAGE)
	GO111MODULE=off CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" CGO_CFLAGS="$(CGO_CFLAGS)" CGO_LDFLAGS="$(CGO_LDFLAGS)" GOPATH=$(GOPATH) $(GO) build $<

web: ../goapps/web/web.go $(CAPGOPACKAGE)
	GO111MODULE=off CGO_ENABLED="$(CGO_REQUIRED)" CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" GOPATH=$(GOPATH) $(GO) build -o $@ $(GOBUILDTAG) $<
ifeq ($(RAISE_GO_FILECAP),yes)
	make -C ../progs setcap
	sudo ../progs/setcap cap_setpcap,cap_net_bind_service=p web
	@echo "NOTE: RAISED cap_setpcap,cap_net_bind_service ON web binary"
endif

ok: ok.go
	GO111MODULE=off CGO_ENABLED=0 GOPATH=$(GOPATH) $(GO) build $<

try-launching: try-launching.go $(CAPGOPACKAGE) ok
	GO111MODULE=off CGO_ENABLED="$(CGO_REQUIRED)" CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" GOPATH=$(GOPATH) $(GO) build $(GOBUILDTAG) $<
ifeq ($(CGO_REQUIRED),0)
	GO111MODULE=off CGO_ENABLED="1" CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" GOPATH=$(GOPATH) $(GO) build -o $@-cgo $<
endif

test: all
	GO111MODULE=off CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" GOPATH="$(GOPATH)" $(GO) test $(IMPORTDIR)/psx
	GO111MODULE=off CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" GOPATH="$(GOPATH)" $(GO) test $(IMPORTDIR)/cap
	LD_LIBRARY_PATH=../libcap ./compare-cap

sudotest: test ../progs/tcapsh-static
	./try-launching
ifeq ($(CGO_REQUIRED),0)
	./try-launching-cgo
endif
	sudo ./try-launching
ifeq ($(CGO_REQUIRED),0)
	sudo ./try-launching-cgo
endif

install: all
	rm -rf $(FAKEROOT)$(GOPKGDIR)/$(IMPORTDIR)/psx
	mkdir -p $(FAKEROOT)$(GOPKGDIR)/$(IMPORTDIR)/psx/include/sys
	for x in src/$(IMPORTDIR)/psx/* ; do if [ -d $$x ]; then continue; fi; install -m 0644 $$x $(FAKEROOT)$(GOPKGDIR)/$(IMPORTDIR)/psx; done
	install -m 0644 src/$(IMPORTDIR)/psx/include/sys/psx_syscall.h $(FAKEROOT)$(GOPKGDIR)/$(IMPORTDIR)/psx/include/sys/psx_syscall.h
	mkdir -p $(FAKEROOT)$(GOPKGDIR)/$(IMPORTDIR)/cap
	rm -rf $(FAKEROOT)$(GOPKGDIR)/$(IMPORTDIR)/cap/*
	install -m 0644 src/$(IMPORTDIR)/cap/* $(FAKEROOT)$(GOPKGDIR)/$(IMPORTDIR)/cap

clean:
	rm -f *.o *.so *~ mknames web ok good-names.go
	rm -f compare-cap try-launching try-launching-cgo
	rm -f $(topdir)/cap/*~ $(topdir)/psx/*~
	rm -fr pkg src

=== libcap/Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 STAPSXLIBNAME=libpsx.a
 
 CAPFILES=cap_alloc cap_proc cap_extint cap_flag cap_text cap_file
-PSXFILES=psx
+PSXFILES=../psx/psx
 
 INCLS=libcap.h cap_names.h $(INCS)
 CAPOBJS=$(addsuffix .o, $(CAPFILES))
@@ -22,7 +22,9 @@
 MINLIBNAME=$(MAJLIBNAME).$(MINOR)
 GPERF_OUTPUT = _caps_output.gperf
 
-all: $(MINLIBNAME) $(STACAPLIBNAME) libcap.pc libpsx.pc $(STAPSXLIBNAME)
+all: $(MINLIBNAME) $(STACAPLIBNAME) pcs $(STAPSXLIBNAME)
+
+pcs: libcap.pc libpsx.pc
 
 ifeq ($(BUILD_GPERF),yes)
 USE_GPERF_OUTPUT = $(GPERF_OUTPUT)
@@ -57,9 +59,14 @@
 	perl -e 'print "struct __cap_token_s { const char *name; int index; };\n%{\nconst struct __cap_token_s *__cap_lookup_name(const char *, size_t);\n%}\n%%\n"; while ($$l = <>) { $$l =~ s/[\{\"]//g; $$l =~ s/\}.*// ; print $$l; }' < $< | gperf --ignore-case --language=ANSI-C --readonly --null-strings --global-table --hash-function-name=__cap_hash_name --lookup-function-name="__cap_lookup_name" -c -t -m20 $(INDENT) > $@
 	sed -e 's/unsigned int len/size_t len/' -i $@
 
-cap_names.list.h: Makefile $(KERNEL_HEADERS)/linux/capability.h
-	@echo "=> making $@ from $(KERNEL_HEADERS)/linux/capability.h"
-	perl -e 'while ($$l=<>) { if ($$l =~ /^\#define[ \t](CAP[_A-Z]+)[ \t]+([0-9]+)\s+$$/) { $$tok=$$1; $$val=$$2; $$tok =~ tr/A-Z/a-z/; print "{\"$$tok\",$$val},\n"; } }' $(KERNEL_HEADERS)/linux/capability.h | fgrep -v 0x > $@
+# Intention is that libcap keeps up with torvalds' tree, as reflected
+# by this maintained version of the kernel header. libcap dynamically
+# trims the meaning of "all" capabilities down to that of the running
+# kernel as of 2.30.
+UAPI_HEADER := $(topdir)/libcap/include/uapi/linux/capability.h
+cap_names.list.h: Makefile $(UAPI_HEADER)
+	@echo "=> making $@ from $(UAPI_HEADER)"
+	perl -e 'while ($$l=<>) { if ($$l =~ /^\#define[ \t](CAP[_A-Z]+)[ \t]+([0-9]+)\s+$$/) { $$tok=$$1; $$val=$$2; $$tok =~ tr/A-Z/a-z/; print "{\"$$tok\",$$val},\n"; } }' $(UAPI_HEADER) | fgrep -v 0x > $@
 
 $(STACAPLIBNAME): $(CAPOBJS)
 	$(AR) rcs $@ $^
@@ -86,22 +93,42 @@
 test: cap_test
 	./cap_test
 
-install: all
-	mkdir -p -m 0755 $(FAKEROOT)$(INCDIR)/sys
-	install -m 0644 include/sys/capability.h $(FAKEROOT)$(INCDIR)/sys
-	install -m 0644 include/sys/psx_syscall.h $(FAKEROOT)$(INCDIR)/sys
-	mkdir -p -m 0755 $(FAKEROOT)$(LIBDIR)
+install: install-static install-shared
+
+install-static: install-static-cap install-static-psx
+
+install-shared: install-shared-cap
+
+install-cap: install-static-cap install-shared-cap
+
+install-psx: install-static-psx
+
+install-static-cap: install-common-cap $(STACAPLIBNAME)
 	install -m 0644 $(STACAPLIBNAME) $(FAKEROOT)$(LIBDIR)/$(STACAPLIBNAME)
-	install -m 0644 $(STAPSXLIBNAME) $(FAKEROOT)$(LIBDIR)/$(STAPSXLIBNAME)
+
+install-shared-cap: install-common-cap $(MINLIBNAME)
 	install -m 0644 $(MINLIBNAME) $(FAKEROOT)$(LIBDIR)/$(MINLIBNAME)
 	ln -sf $(MINLIBNAME) $(FAKEROOT)$(LIBDIR)/$(MAJLIBNAME)
 	ln -sf $(MAJLIBNAME) $(FAKEROOT)$(LIBDIR)/$(LIBNAME)
 ifeq ($(FAKEROOT),)
 	-/sbin/ldconfig
 endif
+
+install-static-psx: install-common-psx $(STAPSXLIBNAME)
+	install -m 0644 $(STAPSXLIBNAME) $(FAKEROOT)$(LIBDIR)/$(STAPSXLIBNAME)
+
+install-common-cap: install-common libcap.pc
+	install -m 0644 include/sys/capability.h $(FAKEROOT)$(INCDIR)/sys
+	install -m 0644 libcap.pc $(FAKEROOT)$(PKGCONFIGDIR)/libcap.pc
+
+install-common-psx: install-common libpsx.pc
+	install -m 0644 include/sys/psx_syscall.h $(FAKEROOT)$(INCDIR)/sys
+	install -m 0644 libpsx.pc $(FAKEROOT)$(PKGCONFIGDIR)/libpsx.pc
+
+install-common:
+	mkdir -p -m 0755 $(FAKEROOT)$(INCDIR)/sys
 	mkdir -p -m 0755 $(FAKEROOT)$(PKGCONFIGDIR)
-	install -m 0644 libcap.pc $(FAKEROOT)$(PKGCONFIGDIR)/libcap.pc
-	install -m 0644 libpsx.pc $(FAKEROOT)$(PKGCONFIGDIR)/libpsx.pc
+	mkdir -p -m 0755 $(FAKEROOT)$(LIBDIR)
 
 clean:
 	$(LOCALCLEAN)

=== progs/Makefile ===
--- 
+++ 
@@ -8,22 +8,26 @@
 
 BUILD=$(PROGS)
 
-ifneq ($(DYNAMIC),yes)
+ifeq ($(DYNAMIC),yes)
+LDPATH = LD_LIBRARY_PATH=../libcap
+DEPSBUILD = all
+else
 LDFLAGS += --static
+DEPSBUILD = libcap.a
 endif
 
-DEPS=../libcap/libcap.a ../libcap/libpsx.a
+DEPS=../libcap/libcap.a
 
 all: $(BUILD)
 
 $(DEPS):
-	make -C ../libcap all
+	make -C ../libcap $(DEPSBUILD)
 
 $(BUILD): %: %.o $(DEPS)
 	$(CC) $(CFLAGS) -o $@ $< $(LIBCAPLIB) $(LDFLAGS)
 
 %.o: %.c $(INCS)
-	$(CC) $(IPATH) $(CFLAGS) -c $< -o $@
+	$(CC) $(IPATH) $(CAPSH_SHELL) $(CFLAGS) -c $< -o $@
 
 install: all
 	mkdir -p -m 0755 $(FAKEROOT)$(SBINDIR)
@@ -36,9 +40,12 @@
 
 test: $(PROGS)
 
-sudotest: test
-	sudo ./quicktest.sh
+tcapsh-static: capsh.c $(DEPS)
+	$(CC) $(IPATH) $(CAPSH_SHELL) $(CFLAGS) -o $@ $< $(LIBCAPLIB) $(LDFLAGS) --static
+
+sudotest: test tcapsh-static
+	sudo $(LDPATH) ./quicktest.sh
 
 clean:
 	$(LOCALCLEAN)
-	rm -f *.o $(BUILD) tcapsh ping hack.sh compare-cap
+	rm -f *.o $(BUILD) tcapsh* privileged ping hack.sh compare-cap

=== tests/Makefile ===
#
# defines
#
topdir=$(shell pwd)/..
include ../Make.Rules
#

DEPS=../libcap/libcap.a ../libcap/libpsx.a

ifeq ($(DYNAMIC),yes)
LDPATH = LD_LIBRARY_PATH=../libcap
DEPSBUILD = all
else
LDFLAGS += --static
DEPSBUILD = libcap.a libpsx.a
endif

all: psx_test libcap_psx_test libcap_launch_test

$(DEPS):
	make -C ../libcap $(DEPSBUILD)

test: run_psx_test run_libcap_psx_test

sudotest: test run_libcap_launch_test run_libcap_launch_test

install: all

run_psx_test: psx_test
	$(LDPATH) ./psx_test

psx_test: psx_test.c $(DEPS)
	$(CC) $(CFLAGS) $(IPATH) $< -o $@ $(LIBPSXLIB)

run_libcap_psx_test: libcap_psx_test
	$(LDPATH) ./libcap_psx_test

libcap_psx_test: libcap_psx_test.c $(DEPS)
	$(CC) $(CFLAGS) $(IPATH) $< -o $@ $(LIBCAPLIB) $(LIBPSXLIB) $(LDFLAGS)

run_libcap_launch_test: libcap_launch_test libcap_psx_launch_test noop
	sudo $(LDPATH) ./libcap_launch_test
	sudo $(LDPATH) ./libcap_psx_launch_test

libcap_launch_test: libcap_launch_test.c $(DEPS)
	$(CC) $(CFLAGS) $(IPATH) $< -o $@ $(LIBCAPLIB) $(LDFLAGS)

# this varies only slightly from the above insofar as it currently
# only links in the pthreads fork support. TODO() we need to change
# the source to do something interesting with pthreads.
libcap_psx_launch_test: libcap_launch_test.c $(DEPS)
	$(CC) $(CFLAGS) $(IPATH) -DWITH_PTHREADS $< -o $@ $(LIBCAPLIB) $(LIBPSXLIB) $(LDFLAGS)

# This one runs in a chroot with no shared library files.
noop: noop.c
	$(CC) $(CFLAGS) $< -o $@ --static

clean:
	rm -f psx_test libcap_psx_test libcap_launch_test *~
	rm -f libcap_launch_test libcap_psx_launch_test core noop

=== contrib/golang/Makefile ===
--- 
+++ 
@@ -1,6 +1,8 @@
+GO := go
+
 all: posix.go posix-cgo.go
-	CGO_ENABLED=0 go build posix.go
-	go build posix-cgo.go
+	CGO_ENABLED=0 $(GO) build posix.go
+	$(GO) build posix-cgo.go
 
 posix.go: ptest.go posix.stub_go Makefile
 	sed -e '/\/\/ main_here/ r posix.stub_go' ptest.go > $@

=== debian/changelog ===
libcap2 (1:2.44-1build3) jammy; urgency=high

  * No change rebuild for ppc64el baseline bump.

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 24 Mar 2022 13:10:52 +0100

libcap2 (1:2.44-1build2) impish; urgency=medium

  * No-change rebuild to build packages with zstd compression.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 07 Oct 2021 12:14:26 +0200

libcap2 (1:2.44-1build1) hirsute; urgency=medium

  * No-change rebuild to drop the udeb package.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 22 Feb 2021 10:34:23 +0100

libcap2 (1:2.44-1) unstable; urgency=medium

  * New upstream release.
    - Refresh patches
  * d/rules: Use new upstream solution for setting -Ox

 -- Christian Kastner <ckk@debian.org>  Wed, 14 Oct 2020 23:49:40 +0200

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,7 @@
 include /usr/share/dpkg/architecture.mk
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
 
 # Support cross-compiling
 ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
@@ -18,13 +19,17 @@
 export BUILD_LDFLAGS = $(shell dpkg-architecture -a$(DEB_BUILD_ARCH) -c dpkg-buildflags --get LDFLAGS)
 export BUILD_CPPFLAGS = $(shell dpkg-architecture -a$(DEB_BUILD_ARCH) -c dpkg-buildflags --get CPPFLAGS)
 
+# Upstream's way of setting optimization
+ifneq (,$(filter noopt, $(DEB_BUILD_OPTIONS)))
+COPTS = COPTS=-O0
+endif
 
 %:
 	dh ${@}
 
 
 override_dh_auto_build:
-	dh_auto_build -- CC=$(CC) BUILD_CC=$(BUILD_CC)
+	dh_auto_build -- CC=$(CC) BUILD_CC=$(BUILD_CC) $(COPTS)
 
 
 override_dh_installdirs:
